--- sysdeps/freebsd/proctime.c.orig	2004-06-09 20:52:21.000000000 +0200
+++ sysdeps/freebsd/proctime.c	2005-01-13 22:46:42.000000000 +0100
@@ -58,7 +58,6 @@
  */
 
 #ifndef __FreeBSD__
-
 static void
 calcru(p, up, sp, ip)
      struct proc *p;
@@ -81,19 +80,10 @@
 		tot = 1;
 	}
 
-#if (defined __FreeBSD__) && (__FreeBSD_version >= 300003)
-
-	/* This was changed from a `struct timeval' into a `guint64'
-	 * on FreeBSD 3.0 and renamed p_rtime -> p_runtime.
-	 */
-
-	totusec = (u_quad_t) p->p_runtime;
-#else
 	sec = p->p_rtime.tv_sec;
 	usec = p->p_rtime.tv_usec;
 
 	totusec = (quad_t)sec * 1000000 + usec;
-#endif
 
 	if (totusec < 0) {
 		/* XXX no %qd in kernel.  Truncate. */
@@ -116,7 +106,6 @@
 		ip->tv_usec = it % 1000000;
 	}
 }
-
 #endif /* !__FreeBSD__ */
 
 /* Provides detailed information about a process. */
@@ -131,12 +120,12 @@
 #else
 	struct user *u_addr = (struct user *)USRSTACK;
 #endif
+#if defined(__DragonFly__)
+	struct rusage pru;
+#endif
 	struct pstats pstats;
 	int count;
 
-	char filename [BUFSIZ];
-	struct stat statb;
-
 	glibtop_init_p (server, (1L << GLIBTOP_SYSDEPS_PROC_TIME), 0);
 
 	memset (buf, 0, sizeof (glibtop_proc_time));
@@ -159,7 +148,12 @@
 	if ((pinfo == NULL) || (count != 1))
 		glibtop_error_io_r (server, "kvm_getprocs (%d)", pid);
 
-#if defined(__FreeBSD__) && (__FreeBSD_version >= 500013)
+#if defined(__DragonFly__)
+        if (!getrusage(pinfo [0].kp_proc.p_pid, &pru)) {
+                glibtop_error_io_r (server, "getrusage (%d)", pid);
+        }
+        buf->rtime = pru.ru_utime.tv_usec;
+#elif defined(__FreeBSD__) && (__FreeBSD_version >= 500013)
 	buf->rtime = pinfo [0].ki_runtime;
 #elif (defined __FreeBSD__) && (__FreeBSD_version <= 500013)
 	buf->rtime = pinfo [0].kp_proc.p_runtime;
@@ -170,7 +164,18 @@
 	buf->frequency = 1000000;
 	buf->flags = _glibtop_sysdeps_proc_time;
 
-#if (defined(__NetBSD__) && (__NetBSD_Version__ >= 104000000)) || (defined(OpenBSD) && (OpenBSD >= 199912))
+#if defined(__DragonFly__)
+	buf->utime = tv2sec (pru.ru_utime);
+	buf->stime = tv2sec (pru.ru_stime);
+
+	buf->cutime = 0;
+	buf->cstime = 0;
+
+	buf->start_time = tv2sec (pinfo[0].kp_thread.td_start);
+
+	buf->flags = _glibtop_sysdeps_proc_time_user;
+
+#elif (defined(__NetBSD__) && (__NetBSD_Version__ >= 104000000)) || (defined(OpenBSD) && (OpenBSD >= 199912))
 	glibtop_suid_enter (server);
 
 	if (kvm_read (server->machine.kd,
