--- sysdeps/freebsd/swap.c.orig	2005-01-13 13:19:06.000000000 +0100
+++ sysdeps/freebsd/swap.c	2005-01-13 13:21:25.000000000 +0100
@@ -162,6 +162,9 @@
 #else
 	/* To get `pagein' and `pageout'. */
 	struct vmmeter vmm;
+#if defined(__DragonFly__)
+	size_t length_vmm;
+#endif
 #endif
         static int swappgsin = -1;
 	static int swappgsout = -1;
@@ -182,12 +185,20 @@
 #else
 	/* This is used to get the `pagein' and `pageout' members. */
 
+#if defined(__DragonFly__)
+	length_vmm = sizeof(vmm);
+	if (sysctlbyname("vm.vmmeter", &vmm, &length_vmm, NULL, 0)) {
+		glibtop_warn_io_r (server, "sysctlbyname (vm.vmmeter)");
+		return;
+	}
+#else
 	if (kvm_read (server->machine.kd, nlst2[0].n_value,
 		      &vmm, sizeof (vmm)) != sizeof (vmm)) {
 		glibtop_warn_io_r (server, "kvm_read (cnt)");
 		return;
 	}
 #endif
+#endif
 
         if (swappgsin < 0) {
 		buf->pagein = 0;
